// SONIC ROBO BLAST 2
//-----------------------------------------------------------------------------
// Copyright (C) 1993-1996 by id Software, Inc.
// Copyright (C) 1998-2000 by DooM Legacy Team.
// Copyright (C) 1999-2014 by Sonic Team Junior.
//
// This program is free software distributed under the
// terms of the GNU General Public License, version 2.
// See the 'LICENSE' file for more details.
//-----------------------------------------------------------------------------
/// \file  sounds.c
/// \brief music/sound tables, and related sound routines

#include "doomtype.h"
#include "i_sound.h"
#include "sounds.h"
#include "r_defs.h"
#include "r_things.h"
#include "z_zone.h"
#include "w_wad.h"
#include "lua_script.h"

//
// Information about all the music
//

musicinfo_t S_music[NUMMUSIC] =
{
	{NULL, 0, NULL, -1},
	{"map01m", 0, NULL, -1},
	{"map02m", 0, NULL, -1},
	{"map03m", 0, NULL, -1},
	{"map04m", 0, NULL, -1},
	{"map05m", 0, NULL, -1},
	{"map06m", 0, NULL, -1},
	{"map07m", 0, NULL, -1},
	{"map08m", 0, NULL, -1},
	{"map09m", 0, NULL, -1},
	{"map10m", 0, NULL, -1},
	{"map11m", 0, NULL, -1},
	{"map12m", 0, NULL, -1},
	{"map13m", 0, NULL, -1},
	{"map14m", 0, NULL, -1},
	{"map15m", 0, NULL, -1},
	{"map16m", 0, NULL, -1},
	{"map17m", 0, NULL, -1},
	{"map18m", 0, NULL, -1},
	{"map19m", 0, NULL, -1},
	{"map20m", 0, NULL, -1},
	{"map21m", 0, NULL, -1},
	{"map22m", 0, NULL, -1},
	{"map23m", 0, NULL, -1},
	{"map24m", 0, NULL, -1},
	{"map25m", 0, NULL, -1},
	{"map26m", 0, NULL, -1},
	{"map27m", 0, NULL, -1},
	{"map28m", 0, NULL, -1},
	{"map29m", 0, NULL, -1},
	{"map30m", 0, NULL, -1},
	{"map31m", 0, NULL, -1},
	{"map32m", 0, NULL, -1},
	{"map33m", 0, NULL, -1},
	{"map34m", 0, NULL, -1},
	{"map35m", 0, NULL, -1},
	{"map36m", 0, NULL, -1},
	{"map37m", 0, NULL, -1},
	{"map38m", 0, NULL, -1},
	{"map39m", 0, NULL, -1},
	{"map40m", 0, NULL, -1},
	{"map41m", 0, NULL, -1},
	{"map42m", 0, NULL, -1},
	{"map43m", 0, NULL, -1},
	{"map44m", 0, NULL, -1},
	{"map45m", 0, NULL, -1},
	{"map46m", 0, NULL, -1},
	{"map47m", 0, NULL, -1},
	{"map48m", 0, NULL, -1},
	{"map49m", 0, NULL, -1},
	{"map50m", 0, NULL, -1},
	{"map51m", 0, NULL, -1},
	{"map52m", 0, NULL, -1},
	{"map53m", 0, NULL, -1},
	{"map54m", 0, NULL, -1},
	{"map55m", 0, NULL, -1},
	{"map56m", 0, NULL, -1},
	{"map57m", 0, NULL, -1},
	{"map58m", 0, NULL, -1},
	{"map59m", 0, NULL, -1},
	{"map60m", 0, NULL, -1},
	{"map61m", 0, NULL, -1},
	{"map62m", 0, NULL, -1},
	{"map63m", 0, NULL, -1},
	{"map64m", 0, NULL, -1},
	{"map65m", 0, NULL, -1},
	{"map66m", 0, NULL, -1},
	{"map67m", 0, NULL, -1},
	{"map68m", 0, NULL, -1},
	{"map69m", 0, NULL, -1},
	{"map70m", 0, NULL, -1},
	{"map71m", 0, NULL, -1},
	{"map72m", 0, NULL, -1},
	{"map73m", 0, NULL, -1},
	{"map74m", 0, NULL, -1},
	{"map75m", 0, NULL, -1},
	{"map76m", 0, NULL, -1},
	{"map77m", 0, NULL, -1},
	{"map78m", 0, NULL, -1},
	{"map79m", 0, NULL, -1},
	{"map80m", 0, NULL, -1},
	{"map81m", 0, NULL, -1},
	{"map82m", 0, NULL, -1},
	{"map83m", 0, NULL, -1},
	{"map84m", 0, NULL, -1},
	{"map85m", 0, NULL, -1},
	{"map86m", 0, NULL, -1},
	{"map87m", 0, NULL, -1},
	{"map88m", 0, NULL, -1},
	{"map89m", 0, NULL, -1},
	{"map90m", 0, NULL, -1},
	{"map91m", 0, NULL, -1},
	{"map92m", 0, NULL, -1},
	{"map93m", 0, NULL, -1},
	{"map94m", 0, NULL, -1},
	{"map95m", 0, NULL, -1},
	{"map96m", 0, NULL, -1},
	{"map97m", 0, NULL, -1},
	{"map98m", 0, NULL, -1},
	{"map99m", 0, NULL, -1},
	{"mapa0m", 0, NULL, -1},
	{"mapa1m", 0, NULL, -1},
	{"mapa2m", 0, NULL, -1},
	{"mapa3m", 0, NULL, -1},
	{"mapa4m", 0, NULL, -1},
	{"mapa5m", 0, NULL, -1},
	{"mapa6m", 0, NULL, -1},
	{"mapa7m", 0, NULL, -1},
	{"mapa8m", 0, NULL, -1},
	{"mapa9m", 0, NULL, -1},
	{"mapaam", 0, NULL, -1},
	{"mapabm", 0, NULL, -1},
	{"mapacm", 0, NULL, -1},
	{"mapadm", 0, NULL, -1},
	{"mapaem", 0, NULL, -1},
	{"mapafm", 0, NULL, -1},
	{"mapagm", 0, NULL, -1},
	{"mapahm", 0, NULL, -1},
	{"mapaim", 0, NULL, -1},
	{"mapajm", 0, NULL, -1},
	{"mapakm", 0, NULL, -1},
	{"mapalm", 0, NULL, -1},
	{"mapamm", 0, NULL, -1},
	{"mapanm", 0, NULL, -1},
	{"mapaom", 0, NULL, -1},
	{"mapapm", 0, NULL, -1},
	{"mapaqm", 0, NULL, -1},
	{"maparm", 0, NULL, -1},
	{"mapasm", 0, NULL, -1},
	{"mapatm", 0, NULL, -1},
	{"mapaum", 0, NULL, -1},
	{"mapavm", 0, NULL, -1},
	{"mapawm", 0, NULL, -1},
	{"mapaxm", 0, NULL, -1},
	{"mapaym", 0, NULL, -1},
	{"mapazm", 0, NULL, -1},
	{"mapb0m", 0, NULL, -1},
	{"mapb1m", 0, NULL, -1},
	{"mapb2m", 0, NULL, -1},
	{"mapb3m", 0, NULL, -1},
	{"mapb4m", 0, NULL, -1},
	{"mapb5m", 0, NULL, -1},
	{"mapb6m", 0, NULL, -1},
	{"mapb7m", 0, NULL, -1},
	{"mapb8m", 0, NULL, -1},
	{"mapb9m", 0, NULL, -1},
	{"mapbam", 0, NULL, -1},
	{"mapbbm", 0, NULL, -1},
	{"mapbcm", 0, NULL, -1},
	{"mapbdm", 0, NULL, -1},
	{"mapbem", 0, NULL, -1},
	{"mapbfm", 0, NULL, -1},
	{"mapbgm", 0, NULL, -1},
	{"mapbhm", 0, NULL, -1},
	{"mapbim", 0, NULL, -1},
	{"mapbjm", 0, NULL, -1},
	{"mapbkm", 0, NULL, -1},
	{"mapblm", 0, NULL, -1},
	{"mapbmm", 0, NULL, -1},
	{"mapbnm", 0, NULL, -1},
	{"mapbom", 0, NULL, -1},
	{"mapbpm", 0, NULL, -1},
	{"mapbqm", 0, NULL, -1},
	{"mapbrm", 0, NULL, -1},
	{"mapbsm", 0, NULL, -1},
	{"mapbtm", 0, NULL, -1},
	{"mapbum", 0, NULL, -1},
	{"mapbvm", 0, NULL, -1},
	{"mapbwm", 0, NULL, -1},
	{"mapbxm", 0, NULL, -1},
	{"mapbym", 0, NULL, -1},
	{"mapbzm", 0, NULL, -1},
	{"mapc0m", 0, NULL, -1},
	{"mapc1m", 0, NULL, -1},
	{"mapc2m", 0, NULL, -1},
	{"mapc3m", 0, NULL, -1},
	{"mapc4m", 0, NULL, -1},
	{"mapc5m", 0, NULL, -1},
	{"mapc6m", 0, NULL, -1},
	{"mapc7m", 0, NULL, -1},
	{"mapc8m", 0, NULL, -1},
	{"mapc9m", 0, NULL, -1},
	{"mapcam", 0, NULL, -1},
	{"mapcbm", 0, NULL, -1},
	{"mapccm", 0, NULL, -1},
	{"mapcdm", 0, NULL, -1},
	{"mapcem", 0, NULL, -1},
	{"mapcfm", 0, NULL, -1},
	{"mapcgm", 0, NULL, -1},
	{"mapchm", 0, NULL, -1},
	{"mapcim", 0, NULL, -1},
	{"mapcjm", 0, NULL, -1},
	{"mapckm", 0, NULL, -1},
	{"mapclm", 0, NULL, -1},
	{"mapcmm", 0, NULL, -1},
	{"mapcnm", 0, NULL, -1},
	{"mapcom", 0, NULL, -1},
	{"mapcpm", 0, NULL, -1},
	{"mapcqm", 0, NULL, -1},
	{"mapcrm", 0, NULL, -1},
	{"mapcsm", 0, NULL, -1},
	{"mapctm", 0, NULL, -1},
	{"mapcum", 0, NULL, -1},
	{"mapcvm", 0, NULL, -1},
	{"mapcwm", 0, NULL, -1},
	{"mapcxm", 0, NULL, -1},
	{"mapcym", 0, NULL, -1},
	{"mapczm", 0, NULL, -1},
	{"mapd0m", 0, NULL, -1},
	{"mapd1m", 0, NULL, -1},
	{"mapd2m", 0, NULL, -1},
	{"mapd3m", 0, NULL, -1},
	{"mapd4m", 0, NULL, -1},
	{"mapd5m", 0, NULL, -1},
	{"mapd6m", 0, NULL, -1},
	{"mapd7m", 0, NULL, -1},
	{"mapd8m", 0, NULL, -1},
	{"mapd9m", 0, NULL, -1},
	{"mapdam", 0, NULL, -1},
	{"mapdbm", 0, NULL, -1},
	{"mapdcm", 0, NULL, -1},
	{"mapddm", 0, NULL, -1},
	{"mapdem", 0, NULL, -1},
	{"mapdfm", 0, NULL, -1},
	{"mapdgm", 0, NULL, -1},
	{"mapdhm", 0, NULL, -1},
	{"mapdim", 0, NULL, -1},
	{"mapdjm", 0, NULL, -1},
	{"mapdkm", 0, NULL, -1},
	{"mapdlm", 0, NULL, -1},
	{"mapdmm", 0, NULL, -1},
	{"mapdnm", 0, NULL, -1},
	{"mapdom", 0, NULL, -1},
	{"mapdpm", 0, NULL, -1},
	{"mapdqm", 0, NULL, -1},
	{"mapdrm", 0, NULL, -1},
	{"mapdsm", 0, NULL, -1},
	{"mapdtm", 0, NULL, -1},
	{"mapdum", 0, NULL, -1},
	{"mapdvm", 0, NULL, -1},
	{"mapdwm", 0, NULL, -1},
	{"mapdxm", 0, NULL, -1},
	{"mapdym", 0, NULL, -1},
	{"mapdzm", 0, NULL, -1},
	{"mape0m", 0, NULL, -1},
	{"mape1m", 0, NULL, -1},
	{"mape2m", 0, NULL, -1},
	{"mape3m", 0, NULL, -1},
	{"mape4m", 0, NULL, -1},
	{"mape5m", 0, NULL, -1},
	{"mape6m", 0, NULL, -1},
	{"mape7m", 0, NULL, -1},
	{"mape8m", 0, NULL, -1},
	{"mape9m", 0, NULL, -1},
	{"mapeam", 0, NULL, -1},
	{"mapebm", 0, NULL, -1},
	{"mapecm", 0, NULL, -1},
	{"mapedm", 0, NULL, -1},
	{"mapeem", 0, NULL, -1},
	{"mapefm", 0, NULL, -1},
	{"mapegm", 0, NULL, -1},
	{"mapehm", 0, NULL, -1},
	{"mapeim", 0, NULL, -1},
	{"mapejm", 0, NULL, -1},
	{"mapekm", 0, NULL, -1},
	{"mapelm", 0, NULL, -1},
	{"mapemm", 0, NULL, -1},
	{"mapenm", 0, NULL, -1},
	{"mapeom", 0, NULL, -1},
	{"mapepm", 0, NULL, -1},
	{"mapeqm", 0, NULL, -1},
	{"maperm", 0, NULL, -1},
	{"mapesm", 0, NULL, -1},
	{"mapetm", 0, NULL, -1},
	{"mapeum", 0, NULL, -1},
	{"mapevm", 0, NULL, -1},
	{"mapewm", 0, NULL, -1},
	{"mapexm", 0, NULL, -1},
	{"mapeym", 0, NULL, -1},
	{"mapezm", 0, NULL, -1},
	{"mapf0m", 0, NULL, -1},
	{"mapf1m", 0, NULL, -1},
	{"mapf2m", 0, NULL, -1},
	{"mapf3m", 0, NULL, -1},
	{"mapf4m", 0, NULL, -1},
	{"mapf5m", 0, NULL, -1},
	{"mapf6m", 0, NULL, -1},
	{"mapf7m", 0, NULL, -1},
	{"mapf8m", 0, NULL, -1},
	{"mapf9m", 0, NULL, -1},
	{"mapfam", 0, NULL, -1},
	{"mapfbm", 0, NULL, -1},
	{"mapfcm", 0, NULL, -1},
	{"mapfdm", 0, NULL, -1},
	{"mapfem", 0, NULL, -1},
	{"mapffm", 0, NULL, -1},
	{"mapfgm", 0, NULL, -1},
	{"mapfhm", 0, NULL, -1},
	{"mapfim", 0, NULL, -1},
	{"mapfjm", 0, NULL, -1},
	{"mapfkm", 0, NULL, -1},
	{"mapflm", 0, NULL, -1},
	{"mapfmm", 0, NULL, -1},
	{"mapfnm", 0, NULL, -1},
	{"mapfom", 0, NULL, -1},
	{"mapfpm", 0, NULL, -1},
	{"mapfqm", 0, NULL, -1},
	{"mapfrm", 0, NULL, -1},
	{"mapfsm", 0, NULL, -1},
	{"mapftm", 0, NULL, -1},
	{"mapfum", 0, NULL, -1},
	{"mapfvm", 0, NULL, -1},
	{"mapfwm", 0, NULL, -1},
	{"mapfxm", 0, NULL, -1},
	{"mapfym", 0, NULL, -1},
	{"mapfzm", 0, NULL, -1},
	{"mapg0m", 0, NULL, -1},
	{"mapg1m", 0, NULL, -1},
	{"mapg2m", 0, NULL, -1},
	{"mapg3m", 0, NULL, -1},
	{"mapg4m", 0, NULL, -1},
	{"mapg5m", 0, NULL, -1},
	{"mapg6m", 0, NULL, -1},
	{"mapg7m", 0, NULL, -1},
	{"mapg8m", 0, NULL, -1},
	{"mapg9m", 0, NULL, -1},
	{"mapgam", 0, NULL, -1},
	{"mapgbm", 0, NULL, -1},
	{"mapgcm", 0, NULL, -1},
	{"mapgdm", 0, NULL, -1},
	{"mapgem", 0, NULL, -1},
	{"mapgfm", 0, NULL, -1},
	{"mapggm", 0, NULL, -1},
	{"mapghm", 0, NULL, -1},
	{"mapgim", 0, NULL, -1},
	{"mapgjm", 0, NULL, -1},
	{"mapgkm", 0, NULL, -1},
	{"mapglm", 0, NULL, -1},
	{"mapgmm", 0, NULL, -1},
	{"mapgnm", 0, NULL, -1},
	{"mapgom", 0, NULL, -1},
	{"mapgpm", 0, NULL, -1},
	{"mapgqm", 0, NULL, -1},
	{"mapgrm", 0, NULL, -1},
	{"mapgsm", 0, NULL, -1},
	{"mapgtm", 0, NULL, -1},
	{"mapgum", 0, NULL, -1},
	{"mapgvm", 0, NULL, -1},
	{"mapgwm", 0, NULL, -1},
	{"mapgxm", 0, NULL, -1},
	{"mapgym", 0, NULL, -1},
	{"mapgzm", 0, NULL, -1},
	{"maph0m", 0, NULL, -1},
	{"maph1m", 0, NULL, -1},
	{"maph2m", 0, NULL, -1},
	{"maph3m", 0, NULL, -1},
	{"maph4m", 0, NULL, -1},
	{"maph5m", 0, NULL, -1},
	{"maph6m", 0, NULL, -1},
	{"maph7m", 0, NULL, -1},
	{"maph8m", 0, NULL, -1},
	{"maph9m", 0, NULL, -1},
	{"mapham", 0, NULL, -1},
	{"maphbm", 0, NULL, -1},
	{"maphcm", 0, NULL, -1},
	{"maphdm", 0, NULL, -1},
	{"maphem", 0, NULL, -1},
	{"maphfm", 0, NULL, -1},
	{"maphgm", 0, NULL, -1},
	{"maphhm", 0, NULL, -1},
	{"maphim", 0, NULL, -1},
	{"maphjm", 0, NULL, -1},
	{"maphkm", 0, NULL, -1},
	{"maphlm", 0, NULL, -1},
	{"maphmm", 0, NULL, -1},
	{"maphnm", 0, NULL, -1},
	{"maphom", 0, NULL, -1},
	{"maphpm", 0, NULL, -1},
	{"maphqm", 0, NULL, -1},
	{"maphrm", 0, NULL, -1},
	{"maphsm", 0, NULL, -1},
	{"maphtm", 0, NULL, -1},
	{"maphum", 0, NULL, -1},
	{"maphvm", 0, NULL, -1},
	{"maphwm", 0, NULL, -1},
	{"maphxm", 0, NULL, -1},
	{"maphym", 0, NULL, -1},
	{"maphzm", 0, NULL, -1},
	{"mapi0m", 0, NULL, -1},
	{"mapi1m", 0, NULL, -1},
	{"mapi2m", 0, NULL, -1},
	{"mapi3m", 0, NULL, -1},
	{"mapi4m", 0, NULL, -1},
	{"mapi5m", 0, NULL, -1},
	{"mapi6m", 0, NULL, -1},
	{"mapi7m", 0, NULL, -1},
	{"mapi8m", 0, NULL, -1},
	{"mapi9m", 0, NULL, -1},
	{"mapiam", 0, NULL, -1},
	{"mapibm", 0, NULL, -1},
	{"mapicm", 0, NULL, -1},
	{"mapidm", 0, NULL, -1},
	{"mapiem", 0, NULL, -1},
	{"mapifm", 0, NULL, -1},
	{"mapigm", 0, NULL, -1},
	{"mapihm", 0, NULL, -1},
	{"mapiim", 0, NULL, -1},
	{"mapijm", 0, NULL, -1},
	{"mapikm", 0, NULL, -1},
	{"mapilm", 0, NULL, -1},
	{"mapimm", 0, NULL, -1},
	{"mapinm", 0, NULL, -1},
	{"mapiom", 0, NULL, -1},
	{"mapipm", 0, NULL, -1},
	{"mapiqm", 0, NULL, -1},
	{"mapirm", 0, NULL, -1},
	{"mapism", 0, NULL, -1},
	{"mapitm", 0, NULL, -1},
	{"mapium", 0, NULL, -1},
	{"mapivm", 0, NULL, -1},
	{"mapiwm", 0, NULL, -1},
	{"mapixm", 0, NULL, -1},
	{"mapiym", 0, NULL, -1},
	{"mapizm", 0, NULL, -1},
	{"mapj0m", 0, NULL, -1},
	{"mapj1m", 0, NULL, -1},
	{"mapj2m", 0, NULL, -1},
	{"mapj3m", 0, NULL, -1},
	{"mapj4m", 0, NULL, -1},
	{"mapj5m", 0, NULL, -1},
	{"mapj6m", 0, NULL, -1},
	{"mapj7m", 0, NULL, -1},
	{"mapj8m", 0, NULL, -1},
	{"mapj9m", 0, NULL, -1},
	{"mapjam", 0, NULL, -1},
	{"mapjbm", 0, NULL, -1},
	{"mapjcm", 0, NULL, -1},
	{"mapjdm", 0, NULL, -1},
	{"mapjem", 0, NULL, -1},
	{"mapjfm", 0, NULL, -1},
	{"mapjgm", 0, NULL, -1},
	{"mapjhm", 0, NULL, -1},
	{"mapjim", 0, NULL, -1},
	{"mapjjm", 0, NULL, -1},
	{"mapjkm", 0, NULL, -1},
	{"mapjlm", 0, NULL, -1},
	{"mapjmm", 0, NULL, -1},
	{"mapjnm", 0, NULL, -1},
	{"mapjom", 0, NULL, -1},
	{"mapjpm", 0, NULL, -1},
	{"mapjqm", 0, NULL, -1},
	{"mapjrm", 0, NULL, -1},
	{"mapjsm", 0, NULL, -1},
	{"mapjtm", 0, NULL, -1},
	{"mapjum", 0, NULL, -1},
	{"mapjvm", 0, NULL, -1},
	{"mapjwm", 0, NULL, -1},
	{"mapjxm", 0, NULL, -1},
	{"mapjym", 0, NULL, -1},
	{"mapjzm", 0, NULL, -1},
	{"mapk0m", 0, NULL, -1},
	{"mapk1m", 0, NULL, -1},
	{"mapk2m", 0, NULL, -1},
	{"mapk3m", 0, NULL, -1},
	{"mapk4m", 0, NULL, -1},
	{"mapk5m", 0, NULL, -1},
	{"mapk6m", 0, NULL, -1},
	{"mapk7m", 0, NULL, -1},
	{"mapk8m", 0, NULL, -1},
	{"mapk9m", 0, NULL, -1},
	{"mapkam", 0, NULL, -1},
	{"mapkbm", 0, NULL, -1},
	{"mapkcm", 0, NULL, -1},
	{"mapkdm", 0, NULL, -1},
	{"mapkem", 0, NULL, -1},
	{"mapkfm", 0, NULL, -1},
	{"mapkgm", 0, NULL, -1},
	{"mapkhm", 0, NULL, -1},
	{"mapkim", 0, NULL, -1},
	{"mapkjm", 0, NULL, -1},
	{"mapkkm", 0, NULL, -1},
	{"mapklm", 0, NULL, -1},
	{"mapkmm", 0, NULL, -1},
	{"mapknm", 0, NULL, -1},
	{"mapkom", 0, NULL, -1},
	{"mapkpm", 0, NULL, -1},
	{"mapkqm", 0, NULL, -1},
	{"mapkrm", 0, NULL, -1},
	{"mapksm", 0, NULL, -1},
	{"mapktm", 0, NULL, -1},
	{"mapkum", 0, NULL, -1},
	{"mapkvm", 0, NULL, -1},
	{"mapkwm", 0, NULL, -1},
	{"mapkxm", 0, NULL, -1},
	{"mapkym", 0, NULL, -1},
	{"mapkzm", 0, NULL, -1},
	{"mapl0m", 0, NULL, -1},
	{"mapl1m", 0, NULL, -1},
	{"mapl2m", 0, NULL, -1},
	{"mapl3m", 0, NULL, -1},
	{"mapl4m", 0, NULL, -1},
	{"mapl5m", 0, NULL, -1},
	{"mapl6m", 0, NULL, -1},
	{"mapl7m", 0, NULL, -1},
	{"mapl8m", 0, NULL, -1},
	{"mapl9m", 0, NULL, -1},
	{"maplam", 0, NULL, -1},
	{"maplbm", 0, NULL, -1},
	{"maplcm", 0, NULL, -1},
	{"mapldm", 0, NULL, -1},
	{"maplem", 0, NULL, -1},
	{"maplfm", 0, NULL, -1},
	{"maplgm", 0, NULL, -1},
	{"maplhm", 0, NULL, -1},
	{"maplim", 0, NULL, -1},
	{"mapljm", 0, NULL, -1},
	{"maplkm", 0, NULL, -1},
	{"mapllm", 0, NULL, -1},
	{"maplmm", 0, NULL, -1},
	{"maplnm", 0, NULL, -1},
	{"maplom", 0, NULL, -1},
	{"maplpm", 0, NULL, -1},
	{"maplqm", 0, NULL, -1},
	{"maplrm", 0, NULL, -1},
	{"maplsm", 0, NULL, -1},
	{"mapltm", 0, NULL, -1},
	{"maplum", 0, NULL, -1},
	{"maplvm", 0, NULL, -1},
	{"maplwm", 0, NULL, -1},
	{"maplxm", 0, NULL, -1},
	{"maplym", 0, NULL, -1},
	{"maplzm", 0, NULL, -1},
	{"mapm0m", 0, NULL, -1},
	{"mapm1m", 0, NULL, -1},
	{"mapm2m", 0, NULL, -1},
	{"mapm3m", 0, NULL, -1},
	{"mapm4m", 0, NULL, -1},
	{"mapm5m", 0, NULL, -1},
	{"mapm6m", 0, NULL, -1},
	{"mapm7m", 0, NULL, -1},
	{"mapm8m", 0, NULL, -1},
	{"mapm9m", 0, NULL, -1},
	{"mapmam", 0, NULL, -1},
	{"mapmbm", 0, NULL, -1},
	{"mapmcm", 0, NULL, -1},
	{"mapmdm", 0, NULL, -1},
	{"mapmem", 0, NULL, -1},
	{"mapmfm", 0, NULL, -1},
	{"mapmgm", 0, NULL, -1},
	{"mapmhm", 0, NULL, -1},
	{"mapmim", 0, NULL, -1},
	{"mapmjm", 0, NULL, -1},
	{"mapmkm", 0, NULL, -1},
	{"mapmlm", 0, NULL, -1},
	{"mapmmm", 0, NULL, -1},
	{"mapmnm", 0, NULL, -1},
	{"mapmom", 0, NULL, -1},
	{"mapmpm", 0, NULL, -1},
	{"mapmqm", 0, NULL, -1},
	{"mapmrm", 0, NULL, -1},
	{"mapmsm", 0, NULL, -1},
	{"mapmtm", 0, NULL, -1},
	{"mapmum", 0, NULL, -1},
	{"mapmvm", 0, NULL, -1},
	{"mapmwm", 0, NULL, -1},
	{"mapmxm", 0, NULL, -1},
	{"mapmym", 0, NULL, -1},
	{"mapmzm", 0, NULL, -1},
	{"mapn0m", 0, NULL, -1},
	{"mapn1m", 0, NULL, -1},
	{"mapn2m", 0, NULL, -1},
	{"mapn3m", 0, NULL, -1},
	{"mapn4m", 0, NULL, -1},
	{"mapn5m", 0, NULL, -1},
	{"mapn6m", 0, NULL, -1},
	{"mapn7m", 0, NULL, -1},
	{"mapn8m", 0, NULL, -1},
	{"mapn9m", 0, NULL, -1},
	{"mapnam", 0, NULL, -1},
	{"mapnbm", 0, NULL, -1},
	{"mapncm", 0, NULL, -1},
	{"mapndm", 0, NULL, -1},
	{"mapnem", 0, NULL, -1},
	{"mapnfm", 0, NULL, -1},
	{"mapngm", 0, NULL, -1},
	{"mapnhm", 0, NULL, -1},
	{"mapnim", 0, NULL, -1},
	{"mapnjm", 0, NULL, -1},
	{"mapnkm", 0, NULL, -1},
	{"mapnlm", 0, NULL, -1},
	{"mapnmm", 0, NULL, -1},
	{"mapnnm", 0, NULL, -1},
	{"mapnom", 0, NULL, -1},
	{"mapnpm", 0, NULL, -1},
	{"mapnqm", 0, NULL, -1},
	{"mapnrm", 0, NULL, -1},
	{"mapnsm", 0, NULL, -1},
	{"mapntm", 0, NULL, -1},
	{"mapnum", 0, NULL, -1},
	{"mapnvm", 0, NULL, -1},
	{"mapnwm", 0, NULL, -1},
	{"mapnxm", 0, NULL, -1},
	{"mapnym", 0, NULL, -1},
	{"mapnzm", 0, NULL, -1},
	{"mapo0m", 0, NULL, -1},
	{"mapo1m", 0, NULL, -1},
	{"mapo2m", 0, NULL, -1},
	{"mapo3m", 0, NULL, -1},
	{"mapo4m", 0, NULL, -1},
	{"mapo5m", 0, NULL, -1},
	{"mapo6m", 0, NULL, -1},
	{"mapo7m", 0, NULL, -1},
	{"mapo8m", 0, NULL, -1},
	{"mapo9m", 0, NULL, -1},
	{"mapoam", 0, NULL, -1},
	{"mapobm", 0, NULL, -1},
	{"mapocm", 0, NULL, -1},
	{"mapodm", 0, NULL, -1},
	{"mapoem", 0, NULL, -1},
	{"mapofm", 0, NULL, -1},
	{"mapogm", 0, NULL, -1},
	{"mapohm", 0, NULL, -1},
	{"mapoim", 0, NULL, -1},
	{"mapojm", 0, NULL, -1},
	{"mapokm", 0, NULL, -1},
	{"mapolm", 0, NULL, -1},
	{"mapomm", 0, NULL, -1},
	{"maponm", 0, NULL, -1},
	{"mapoom", 0, NULL, -1},
	{"mapopm", 0, NULL, -1},
	{"mapoqm", 0, NULL, -1},
	{"maporm", 0, NULL, -1},
	{"maposm", 0, NULL, -1},
	{"mapotm", 0, NULL, -1},
	{"mapoum", 0, NULL, -1},
	{"mapovm", 0, NULL, -1},
	{"mapowm", 0, NULL, -1},
	{"mapoxm", 0, NULL, -1},
	{"mapoym", 0, NULL, -1},
	{"mapozm", 0, NULL, -1},
	{"mapp0m", 0, NULL, -1},
	{"mapp1m", 0, NULL, -1},
	{"mapp2m", 0, NULL, -1},
	{"mapp3m", 0, NULL, -1},
	{"mapp4m", 0, NULL, -1},
	{"mapp5m", 0, NULL, -1},
	{"mapp6m", 0, NULL, -1},
	{"mapp7m", 0, NULL, -1},
	{"mapp8m", 0, NULL, -1},
	{"mapp9m", 0, NULL, -1},
	{"mappam", 0, NULL, -1},
	{"mappbm", 0, NULL, -1},
	{"mappcm", 0, NULL, -1},
	{"mappdm", 0, NULL, -1},
	{"mappem", 0, NULL, -1},
	{"mappfm", 0, NULL, -1},
	{"mappgm", 0, NULL, -1},
	{"mapphm", 0, NULL, -1},
	{"mappim", 0, NULL, -1},
	{"mappjm", 0, NULL, -1},
	{"mappkm", 0, NULL, -1},
	{"mapplm", 0, NULL, -1},
	{"mappmm", 0, NULL, -1},
	{"mappnm", 0, NULL, -1},
	{"mappom", 0, NULL, -1},
	{"mapppm", 0, NULL, -1},
	{"mappqm", 0, NULL, -1},
	{"mapprm", 0, NULL, -1},
	{"mappsm", 0, NULL, -1},
	{"mapptm", 0, NULL, -1},
	{"mappum", 0, NULL, -1},
	{"mappvm", 0, NULL, -1},
	{"mappwm", 0, NULL, -1},
	{"mappxm", 0, NULL, -1},
	{"mappym", 0, NULL, -1},
	{"mappzm", 0, NULL, -1},
	{"mapq0m", 0, NULL, -1},
	{"mapq1m", 0, NULL, -1},
	{"mapq2m", 0, NULL, -1},
	{"mapq3m", 0, NULL, -1},
	{"mapq4m", 0, NULL, -1},
	{"mapq5m", 0, NULL, -1},
	{"mapq6m", 0, NULL, -1},
	{"mapq7m", 0, NULL, -1},
	{"mapq8m", 0, NULL, -1},
	{"mapq9m", 0, NULL, -1},
	{"mapqam", 0, NULL, -1},
	{"mapqbm", 0, NULL, -1},
	{"mapqcm", 0, NULL, -1},
	{"mapqdm", 0, NULL, -1},
	{"mapqem", 0, NULL, -1},
	{"mapqfm", 0, NULL, -1},
	{"mapqgm", 0, NULL, -1},
	{"mapqhm", 0, NULL, -1},
	{"mapqim", 0, NULL, -1},
	{"mapqjm", 0, NULL, -1},
	{"mapqkm", 0, NULL, -1},
	{"mapqlm", 0, NULL, -1},
	{"mapqmm", 0, NULL, -1},
	{"mapqnm", 0, NULL, -1},
	{"mapqom", 0, NULL, -1},
	{"mapqpm", 0, NULL, -1},
	{"mapqqm", 0, NULL, -1},
	{"mapqrm", 0, NULL, -1},
	{"mapqsm", 0, NULL, -1},
	{"mapqtm", 0, NULL, -1},
	{"mapqum", 0, NULL, -1},
	{"mapqvm", 0, NULL, -1},
	{"mapqwm", 0, NULL, -1},
	{"mapqxm", 0, NULL, -1},
	{"mapqym", 0, NULL, -1},
	{"mapqzm", 0, NULL, -1},
	{"mapr0m", 0, NULL, -1},
	{"mapr1m", 0, NULL, -1},
	{"mapr2m", 0, NULL, -1},
	{"mapr3m", 0, NULL, -1},
	{"mapr4m", 0, NULL, -1},
	{"mapr5m", 0, NULL, -1},
	{"mapr6m", 0, NULL, -1},
	{"mapr7m", 0, NULL, -1},
	{"mapr8m", 0, NULL, -1},
	{"mapr9m", 0, NULL, -1},
	{"mapram", 0, NULL, -1},
	{"maprbm", 0, NULL, -1},
	{"maprcm", 0, NULL, -1},
	{"maprdm", 0, NULL, -1},
	{"maprem", 0, NULL, -1},
	{"maprfm", 0, NULL, -1},
	{"maprgm", 0, NULL, -1},
	{"maprhm", 0, NULL, -1},
	{"maprim", 0, NULL, -1},
	{"maprjm", 0, NULL, -1},
	{"maprkm", 0, NULL, -1},
	{"maprlm", 0, NULL, -1},
	{"maprmm", 0, NULL, -1},
	{"maprnm", 0, NULL, -1},
	{"maprom", 0, NULL, -1},
	{"maprpm", 0, NULL, -1},
	{"maprqm", 0, NULL, -1},
	{"maprrm", 0, NULL, -1},
	{"maprsm", 0, NULL, -1},
	{"maprtm", 0, NULL, -1},
	{"maprum", 0, NULL, -1},
	{"maprvm", 0, NULL, -1},
	{"maprwm", 0, NULL, -1},
	{"maprxm", 0, NULL, -1},
	{"maprym", 0, NULL, -1},
	{"maprzm", 0, NULL, -1},
	{"maps0m", 0, NULL, -1},
	{"maps1m", 0, NULL, -1},
	{"maps2m", 0, NULL, -1},
	{"maps3m", 0, NULL, -1},
	{"maps4m", 0, NULL, -1},
	{"maps5m", 0, NULL, -1},
	{"maps6m", 0, NULL, -1},
	{"maps7m", 0, NULL, -1},
	{"maps8m", 0, NULL, -1},
	{"maps9m", 0, NULL, -1},
	{"mapsam", 0, NULL, -1},
	{"mapsbm", 0, NULL, -1},
	{"mapscm", 0, NULL, -1},
	{"mapsdm", 0, NULL, -1},
	{"mapsem", 0, NULL, -1},
	{"mapsfm", 0, NULL, -1},
	{"mapsgm", 0, NULL, -1},
	{"mapshm", 0, NULL, -1},
	{"mapsim", 0, NULL, -1},
	{"mapsjm", 0, NULL, -1},
	{"mapskm", 0, NULL, -1},
	{"mapslm", 0, NULL, -1},
	{"mapsmm", 0, NULL, -1},
	{"mapsnm", 0, NULL, -1},
	{"mapsom", 0, NULL, -1},
	{"mapspm", 0, NULL, -1},
	{"mapsqm", 0, NULL, -1},
	{"mapsrm", 0, NULL, -1},
	{"mapssm", 0, NULL, -1},
	{"mapstm", 0, NULL, -1},
	{"mapsum", 0, NULL, -1},
	{"mapsvm", 0, NULL, -1},
	{"mapswm", 0, NULL, -1},
	{"mapsxm", 0, NULL, -1},
	{"mapsym", 0, NULL, -1},
	{"mapszm", 0, NULL, -1},
	{"mapt0m", 0, NULL, -1},
	{"mapt1m", 0, NULL, -1},
	{"mapt2m", 0, NULL, -1},
	{"mapt3m", 0, NULL, -1},
	{"mapt4m", 0, NULL, -1},
	{"mapt5m", 0, NULL, -1},
	{"mapt6m", 0, NULL, -1},
	{"mapt7m", 0, NULL, -1},
	{"mapt8m", 0, NULL, -1},
	{"mapt9m", 0, NULL, -1},
	{"maptam", 0, NULL, -1},
	{"maptbm", 0, NULL, -1},
	{"maptcm", 0, NULL, -1},
	{"maptdm", 0, NULL, -1},
	{"maptem", 0, NULL, -1},
	{"maptfm", 0, NULL, -1},
	{"maptgm", 0, NULL, -1},
	{"mapthm", 0, NULL, -1},
	{"maptim", 0, NULL, -1},
	{"maptjm", 0, NULL, -1},
	{"maptkm", 0, NULL, -1},
	{"maptlm", 0, NULL, -1},
	{"maptmm", 0, NULL, -1},
	{"maptnm", 0, NULL, -1},
	{"maptom", 0, NULL, -1},
	{"maptpm", 0, NULL, -1},
	{"maptqm", 0, NULL, -1},
	{"maptrm", 0, NULL, -1},
	{"maptsm", 0, NULL, -1},
	{"mapttm", 0, NULL, -1},
	{"maptum", 0, NULL, -1},
	{"maptvm", 0, NULL, -1},
	{"maptwm", 0, NULL, -1},
	{"maptxm", 0, NULL, -1},
	{"maptym", 0, NULL, -1},
	{"maptzm", 0, NULL, -1},
	{"mapu0m", 0, NULL, -1},
	{"mapu1m", 0, NULL, -1},
	{"mapu2m", 0, NULL, -1},
	{"mapu3m", 0, NULL, -1},
	{"mapu4m", 0, NULL, -1},
	{"mapu5m", 0, NULL, -1},
	{"mapu6m", 0, NULL, -1},
	{"mapu7m", 0, NULL, -1},
	{"mapu8m", 0, NULL, -1},
	{"mapu9m", 0, NULL, -1},
	{"mapuam", 0, NULL, -1},
	{"mapubm", 0, NULL, -1},
	{"mapucm", 0, NULL, -1},
	{"mapudm", 0, NULL, -1},
	{"mapuem", 0, NULL, -1},
	{"mapufm", 0, NULL, -1},
	{"mapugm", 0, NULL, -1},
	{"mapuhm", 0, NULL, -1},
	{"mapuim", 0, NULL, -1},
	{"mapujm", 0, NULL, -1},
	{"mapukm", 0, NULL, -1},
	{"mapulm", 0, NULL, -1},
	{"mapumm", 0, NULL, -1},
	{"mapunm", 0, NULL, -1},
	{"mapuom", 0, NULL, -1},
	{"mapupm", 0, NULL, -1},
	{"mapuqm", 0, NULL, -1},
	{"mapurm", 0, NULL, -1},
	{"mapusm", 0, NULL, -1},
	{"maputm", 0, NULL, -1},
	{"mapuum", 0, NULL, -1},
	{"mapuvm", 0, NULL, -1},
	{"mapuwm", 0, NULL, -1},
	{"mapuxm", 0, NULL, -1},
	{"mapuym", 0, NULL, -1},
	{"mapuzm", 0, NULL, -1},
	{"mapv0m", 0, NULL, -1},
	{"mapv1m", 0, NULL, -1},
	{"mapv2m", 0, NULL, -1},
	{"mapv3m", 0, NULL, -1},
	{"mapv4m", 0, NULL, -1},
	{"mapv5m", 0, NULL, -1},
	{"mapv6m", 0, NULL, -1},
	{"mapv7m", 0, NULL, -1},
	{"mapv8m", 0, NULL, -1},
	{"mapv9m", 0, NULL, -1},
	{"mapvam", 0, NULL, -1},
	{"mapvbm", 0, NULL, -1},
	{"mapvcm", 0, NULL, -1},
	{"mapvdm", 0, NULL, -1},
	{"mapvem", 0, NULL, -1},
	{"mapvfm", 0, NULL, -1},
	{"mapvgm", 0, NULL, -1},
	{"mapvhm", 0, NULL, -1},
	{"mapvim", 0, NULL, -1},
	{"mapvjm", 0, NULL, -1},
	{"mapvkm", 0, NULL, -1},
	{"mapvlm", 0, NULL, -1},
	{"mapvmm", 0, NULL, -1},
	{"mapvnm", 0, NULL, -1},
	{"mapvom", 0, NULL, -1},
	{"mapvpm", 0, NULL, -1},
	{"mapvqm", 0, NULL, -1},
	{"mapvrm", 0, NULL, -1},
	{"mapvsm", 0, NULL, -1},
	{"mapvtm", 0, NULL, -1},
	{"mapvum", 0, NULL, -1},
	{"mapvvm", 0, NULL, -1},
	{"mapvwm", 0, NULL, -1},
	{"mapvxm", 0, NULL, -1},
	{"mapvym", 0, NULL, -1},
	{"mapvzm", 0, NULL, -1},
	{"mapw0m", 0, NULL, -1},
	{"mapw1m", 0, NULL, -1},
	{"mapw2m", 0, NULL, -1},
	{"mapw3m", 0, NULL, -1},
	{"mapw4m", 0, NULL, -1},
	{"mapw5m", 0, NULL, -1},
	{"mapw6m", 0, NULL, -1},
	{"mapw7m", 0, NULL, -1},
	{"mapw8m", 0, NULL, -1},
	{"mapw9m", 0, NULL, -1},
	{"mapwam", 0, NULL, -1},
	{"mapwbm", 0, NULL, -1},
	{"mapwcm", 0, NULL, -1},
	{"mapwdm", 0, NULL, -1},
	{"mapwem", 0, NULL, -1},
	{"mapwfm", 0, NULL, -1},
	{"mapwgm", 0, NULL, -1},
	{"mapwhm", 0, NULL, -1},
	{"mapwim", 0, NULL, -1},
	{"mapwjm", 0, NULL, -1},
	{"mapwkm", 0, NULL, -1},
	{"mapwlm", 0, NULL, -1},
	{"mapwmm", 0, NULL, -1},
	{"mapwnm", 0, NULL, -1},
	{"mapwom", 0, NULL, -1},
	{"mapwpm", 0, NULL, -1},
	{"mapwqm", 0, NULL, -1},
	{"mapwrm", 0, NULL, -1},
	{"mapwsm", 0, NULL, -1},
	{"mapwtm", 0, NULL, -1},
	{"mapwum", 0, NULL, -1},
	{"mapwvm", 0, NULL, -1},
	{"mapwwm", 0, NULL, -1},
	{"mapwxm", 0, NULL, -1},
	{"mapwym", 0, NULL, -1},
	{"mapwzm", 0, NULL, -1},
	{"mapx0m", 0, NULL, -1},
	{"mapx1m", 0, NULL, -1},
	{"mapx2m", 0, NULL, -1},
	{"mapx3m", 0, NULL, -1},
	{"mapx4m", 0, NULL, -1},
	{"mapx5m", 0, NULL, -1},
	{"mapx6m", 0, NULL, -1},
	{"mapx7m", 0, NULL, -1},
	{"mapx8m", 0, NULL, -1},
	{"mapx9m", 0, NULL, -1},
	{"mapxam", 0, NULL, -1},
	{"mapxbm", 0, NULL, -1},
	{"mapxcm", 0, NULL, -1},
	{"mapxdm", 0, NULL, -1},
	{"mapxem", 0, NULL, -1},
	{"mapxfm", 0, NULL, -1},
	{"mapxgm", 0, NULL, -1},
	{"mapxhm", 0, NULL, -1},
	{"mapxim", 0, NULL, -1},
	{"mapxjm", 0, NULL, -1},
	{"mapxkm", 0, NULL, -1},
	{"mapxlm", 0, NULL, -1},
	{"mapxmm", 0, NULL, -1},
	{"mapxnm", 0, NULL, -1},
	{"mapxom", 0, NULL, -1},
	{"mapxpm", 0, NULL, -1},
	{"mapxqm", 0, NULL, -1},
	{"mapxrm", 0, NULL, -1},
	{"mapxsm", 0, NULL, -1},
	{"mapxtm", 0, NULL, -1},
	{"mapxum", 0, NULL, -1},
	{"mapxvm", 0, NULL, -1},
	{"mapxwm", 0, NULL, -1},
	{"mapxxm", 0, NULL, -1},
	{"mapxym", 0, NULL, -1},
	{"mapxzm", 0, NULL, -1},
	{"mapy0m", 0, NULL, -1},
	{"mapy1m", 0, NULL, -1},
	{"mapy2m", 0, NULL, -1},
	{"mapy3m", 0, NULL, -1},
	{"mapy4m", 0, NULL, -1},
	{"mapy5m", 0, NULL, -1},
	{"mapy6m", 0, NULL, -1},
	{"mapy7m", 0, NULL, -1},
	{"mapy8m", 0, NULL, -1},
	{"mapy9m", 0, NULL, -1},
	{"mapyam", 0, NULL, -1},
	{"mapybm", 0, NULL, -1},
	{"mapycm", 0, NULL, -1},
	{"mapydm", 0, NULL, -1},
	{"mapyem", 0, NULL, -1},
	{"mapyfm", 0, NULL, -1},
	{"mapygm", 0, NULL, -1},
	{"mapyhm", 0, NULL, -1},
	{"mapyim", 0, NULL, -1},
	{"mapyjm", 0, NULL, -1},
	{"mapykm", 0, NULL, -1},
	{"mapylm", 0, NULL, -1},
	{"mapymm", 0, NULL, -1},
	{"mapynm", 0, NULL, -1},
	{"mapyom", 0, NULL, -1},
	{"mapypm", 0, NULL, -1},
	{"mapyqm", 0, NULL, -1},
	{"mapyrm", 0, NULL, -1},
	{"mapysm", 0, NULL, -1},
	{"mapytm", 0, NULL, -1},
	{"mapyum", 0, NULL, -1},
	{"mapyvm", 0, NULL, -1},
	{"mapywm", 0, NULL, -1},
	{"mapyxm", 0, NULL, -1},
	{"mapyym", 0, NULL, -1},
	{"mapyzm", 0, NULL, -1},
	{"mapz0m", 0, NULL, -1},
	{"mapz1m", 0, NULL, -1},
	{"mapz2m", 0, NULL, -1},
	{"mapz3m", 0, NULL, -1},
	{"mapz4m", 0, NULL, -1},
	{"mapz5m", 0, NULL, -1},
	{"mapz6m", 0, NULL, -1},
	{"mapz7m", 0, NULL, -1},
	{"mapz8m", 0, NULL, -1},
	{"mapz9m", 0, NULL, -1},
	{"mapzam", 0, NULL, -1},
	{"mapzbm", 0, NULL, -1},
	{"mapzcm", 0, NULL, -1},
	{"mapzdm", 0, NULL, -1},
	{"mapzem", 0, NULL, -1},
	{"mapzfm", 0, NULL, -1},
	{"mapzgm", 0, NULL, -1},
	{"mapzhm", 0, NULL, -1},
	{"mapzim", 0, NULL, -1},
	{"mapzjm", 0, NULL, -1},
	{"mapzkm", 0, NULL, -1},
	{"mapzlm", 0, NULL, -1},
	{"mapzmm", 0, NULL, -1},
	{"mapznm", 0, NULL, -1},
	{"mapzom", 0, NULL, -1},
	{"mapzpm", 0, NULL, -1},
	{"mapzqm", 0, NULL, -1},
	{"mapzrm", 0, NULL, -1},
	{"mapzsm", 0, NULL, -1},
	{"mapztm", 0, NULL, -1},
	{"mapzum", 0, NULL, -1},
	{"mapzvm", 0, NULL, -1},
	{"mapzwm", 0, NULL, -1},
	{"mapzxm", 0, NULL, -1},
	{"mapzym", 0, NULL, -1},
	{"mapzzm", 0, NULL, -1},

	{"titles", 0, NULL, -1}, // Title screen
	{"read_m", 0, NULL, -1}, // Intro
	{"lclear", 0, NULL, -1}, // Level clear
	{"invinc", 0, NULL, -1}, // Invincibility
	{"shoes", 0, NULL, -1}, // Super sneakers
	{"minvnc", 0, NULL, -1}, // Mario invincibility
	{"drown", 0, NULL, -1}, // Drowning
	{"gmover", 0, NULL, -1}, // Game over
	{"xtlife", 0, NULL, -1}, // Extra life
	{"contsc", 0, NULL, -1}, // Continue screen
	{"supers", 0, NULL, -1}, // Super Sonic
	{"chrsel", 0, NULL, -1}, // Character select
	{"credit", 0, NULL, -1}, // Credits
	{"racent", 0, NULL, -1}, // Race Results
	{"stjr",   0, NULL, -1}, // Sonic Team Jr. Presents
};


//
// Information about all the sfx
//

sfxinfo_t S_sfx[NUMSFX] =
{

/*****
	Legacy doesn't use the PITCH variable, so now it is used for
	various flags. See soundflags_t.
*****/
  // S_sfx[0] needs to be a dummy for odd reasons. (don't modify this comment)
//  name, singularity, priority, pitch, volume, data, length, skinsound, usefulness, lumpnum
  {"none" ,  false,   0,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // Skin Sounds
  {"altdi1", false, 192, 16, -1, NULL, 0, SKSPLDET1,  -1, LUMPERROR},
  {"altdi2", false, 192, 16, -1, NULL, 0, SKSPLDET2,  -1, LUMPERROR},
  {"altdi3", false, 192, 16, -1, NULL, 0, SKSPLDET3,  -1, LUMPERROR},
  {"altdi4", false, 192, 16, -1, NULL, 0, SKSPLDET4,  -1, LUMPERROR},
  {"altow1", false, 192, 16, -1, NULL, 0, SKSPLPAN1,  -1, LUMPERROR},
  {"altow2", false, 192, 16, -1, NULL, 0, SKSPLPAN2,  -1, LUMPERROR},
  {"altow3", false, 192, 16, -1, NULL, 0, SKSPLPAN3,  -1, LUMPERROR},
  {"altow4", false, 192, 16, -1, NULL, 0, SKSPLPAN4,  -1, LUMPERROR},
  {"victr1", false,  64, 16, -1, NULL, 0, SKSPLVCT1,  -1, LUMPERROR},
  {"victr2", false,  64, 16, -1, NULL, 0, SKSPLVCT2,  -1, LUMPERROR},
  {"victr3", false,  64, 16, -1, NULL, 0, SKSPLVCT3,  -1, LUMPERROR},
  {"victr4", false,  64, 16, -1, NULL, 0, SKSPLVCT4,  -1, LUMPERROR},
  {"gasp" ,  false,  64,  0, -1, NULL, 0,   SKSGASP,  -1, LUMPERROR},
  {"jump" ,  false, 140,  0, -1, NULL, 0,   SKSJUMP,  -1, LUMPERROR},
  {"pudpud", false,  64,  0, -1, NULL, 0, SKSPUDPUD,  -1, LUMPERROR},
  {"putput", false,  64,  0, -1, NULL, 0, SKSPUTPUT,  -1, LUMPERROR}, // not as high a priority
  {"spin" ,  false, 100,  0, -1, NULL, 0,   SKSSPIN,  -1, LUMPERROR},
  {"spndsh", false,  64,  1, -1, NULL, 0, SKSSPNDSH,  -1, LUMPERROR},
  {"thok" ,  false,  96,  0, -1, NULL, 0,   SKSTHOK,  -1, LUMPERROR},
  {"zoom" ,  false, 120,  1, -1, NULL, 0,   SKSZOOM,  -1, LUMPERROR},
  {"skid",   false,  64, 32, -1, NULL, 0,   SKSSKID,  -1, LUMPERROR},

  // Ambience/background objects/etc
  {"ambint",  true,  32,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},

  {"alarm",  false,  32,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"buzz1",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"buzz2",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"buzz3",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"buzz4",  false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"crumbl",  true, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Platform Crumble Tails 03-16-2001
  {"fire",   false,   8, 32, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"grind",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"laser",   true,  16,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mswing", false,  16,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"pstart", false, 100,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"pstop",  false, 100,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"steam1", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Tails 06-19-2001
  {"steam2", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Tails 06-19-2001
  {"wbreak", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},

  {"rainin",  true,  24,  4, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"litng1", false,  16,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"litng2", false,  16,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"litng3", false,  16,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"litng4", false,  16,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"athun1", false,  16,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"athun2", false,  16,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},

  {"amwtr1", false,  12,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"amwtr2", false,  12,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"amwtr3", false,  12,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"amwtr4", false,  12,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"amwtr5", false,  12,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"amwtr6", false,  12,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"amwtr7", false,  12,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"amwtr8", false,  12,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bubbl1", false,  11,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bubbl2", false,  11,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bubbl3", false,  11,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bubbl4", false,  11,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bubbl5", false,  11,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"floush", false,  16,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"splash", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"splish", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Splish Tails 12-08-2000
  {"wdrip1", false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wdrip2", false,   8 , 0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wdrip3", false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wdrip4", false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wdrip5", false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wdrip6", false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wdrip7", false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wdrip8", false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wslap",  false,  32,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Water Slap Tails 12-13-2000

  {"doora1", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"doorb1", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"doorc1", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"doorc2", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"doord1", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"doord2", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"eleva1", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"eleva2", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"eleva3", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"elevb1", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"elevb2", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"elevb3", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},

  {"ambin2", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"lavbub", false,  64,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rocks1", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rocks2", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rocks3", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rocks4", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rumbam", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rumble", false,  64, 24, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // Game objects, etc
  {"appear", false, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bkpoof", false,  70,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bnce1",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Boing!
  {"bnce2",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Boing!
  {"cannon", false,  64,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"cgot" ,   true, 120,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Got Emerald! Tails 09-02-2001
  {"cybdth", false,  32,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"deton",   true,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"ding",   false, 127,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"dmpain", false,  96,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"drown",  false, 192,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"fizzle", false, 127,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"gbeep",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Grenade beep
  {"gclose", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"ghit" ,  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"gloop",  false,  60,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"gspray", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"gravch", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"itemup",  true, 255,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"jet",    false,   8,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"jshard",  true, 167,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"lose" ,  false, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"lvpass", false,  96,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mindig", false,   8, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mixup",   true, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"pogo" ,  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"pop"  ,  false,  78,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rail1",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rail2",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"rlaunc", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"shield", false,  60,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"shldls", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"spdpad", false, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"spkdth", false, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"spring", false, 112,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"statu1",  true,  64,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"statu2",  true,  64,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"strpst",  true, 192,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Starpost Sound Tails 07-04-2002
  {"supert",  true, 127,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"telept", false,  32,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"tink" ,  false,  60,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"token" ,  true, 224,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // SS token
  {"trfire",  true,  60,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"trpowr",  true, 127,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"turhit", false,  40,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wdjump", false,  60,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mswarp", false,  60, 16, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mspogo", false,  60,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // Menu, interface
  {"chchng", false, 120,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"dwnind", false, 212,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"emfind", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"flgcap", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"menu1",   true,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"oneup",   true, 192,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"ptally",  true,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Point tally is identical to menu for now
  {"radio",  false,  60,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"wepchg",  true,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Weapon switch is identical to menu for now
  {"wtrdng",  true, 212,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // make sure you can hear the DING DING! Tails 03-08-2000
  {"zelda",  false, 120,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // NiGHTS
  {"ideya",  false, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"xideya", false, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Xmas
  {"nbmper", false,  96,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"nxbump", false,  96,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Xmas
  {"ncitem", false, 204,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"nxitem", false, 204,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Xmas
  {"ngdone",  true, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"nxdone",  true, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Xmas
  {"drill1", false,  48,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"drill2", false,  48,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"ncspec", false, 204,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Tails 12-15-2003
  {"nghurt", false,  96,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"ngskid", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"hoop1",  false, 192,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"hoop2",  false, 192,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"hoop3",  false, 192,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"hidden", false, 204,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"prloop", false, 104,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"timeup",  true, 256,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // Mario
  {"koopfr" , true, 127,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario1", false,  60,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario2", false, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario3", false,  60,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario4",  true,  78,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario5", false,  78,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario6", false,  60,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario7", false,  32,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario8", false,  48,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"mario9",  true, 120,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"marioa",  true, 127,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"thwomp",  true, 127,  8, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // Black Eggman
  {"bebomb", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bechrg", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"becrsh", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bedeen", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bedie1", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bedie2", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"beeyow", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"befall", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"befire", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"beflap", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"begoop", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"begrnd", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"behurt", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bejet1", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"belnch", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"beoutb", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"beragh", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"beshot", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bestep", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bestp2", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bewar1", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bewar2", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bewar3", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bewar4", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bexpld", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"bgxpld", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // Cybrakdemon
  {"beelec", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"brakrl", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"brakrx", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // S3&K sounds
  {"s3k33",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k34",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k35",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k36",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k37",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k38",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k39",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k3a",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k3b",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k3c",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k3d",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k3e",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k3f",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k40",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k41",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k42",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k43",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k44",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k45",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k46",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k47",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k48",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k49",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k4a",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k4b",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k4c",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k4d",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k4e",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k4f",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k50",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k51",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k52",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k53",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k54",  false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR}, // MetalSonic shot fire
  {"s3k55",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k56",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k57",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k58",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k59",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k5a",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k5b",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k5c",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k5d",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k5e",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k5f",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k60",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k61",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k62",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k63",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k64",  false,  64,  2, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k65",  false, 255,  0, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Blue Spheres
  {"s3k66",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k67",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k68",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k69",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k6a",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k6b",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k6c",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k6d",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k6e",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k6f",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k70",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k71",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k72",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k73",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k74",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k75",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k76",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k77",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k78",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k79",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k7a",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k7b",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k7c",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k7d",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k7e",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k7f",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k80",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k81",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k82",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k83",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k84",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k85",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k86",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k87",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k88",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k89",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k8a",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k8b",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k8c",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k8d",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k8e",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k8f",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k90",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k91",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k92",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k93",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k94",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k95",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k96",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k97",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k98",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k99",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k9a",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k9b",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k9c",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k9d",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k9e",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3k9f",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka0",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka1",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka2",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka3",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka4",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka5",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka6",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka7",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka8",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3ka9",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kaa",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kab",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kac",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kad",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kae",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kaf",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb0",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb1",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb2",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb3",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb4",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb5",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb6",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb7",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb8",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kb9",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kba",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbb",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbcs", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbcl", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbds", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbdl", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbes", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbel", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbfs", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kbfl", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc0s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc0l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc1s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc1l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc2s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc2l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc3s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc3l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc4s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc4l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc5s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc5l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc6s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc6l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc7",  false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc8s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc8l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc9s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kc9l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcas", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcal", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcbs", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcbl", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kccs", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kccl", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcds", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcdl", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kces", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcel", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcfs", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kcfl", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd0s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd0l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd1s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd1l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd2s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd2l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd3s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd3l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd4s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd4l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd5s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd5l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd6s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd6l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd7s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd7l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd8s", false,  64, 64, -1, NULL, 0,        -1,  -1, LUMPERROR}, // Sharp Spin (maybe use the long/L version?)
  {"s3kd8l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd9s", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kd9l", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kdas", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kdal", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kdbs", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},
  {"s3kdbl", false,  64,  0, -1, NULL, 0,        -1,  -1, LUMPERROR},

  // skin sounds free slots to add sounds at run time (Boris HACK!!!)
  // initialized to NULL
};

char freeslotnames[sfx_freeslot0 + NUMSFXFREESLOTS + NUMSKINSFXSLOTS][7];

// Prepare free sfx slots to add sfx at run time
void S_InitRuntimeSounds (void)
{
	sfxenum_t i;
	INT32 value;
	char soundname[7];

	for (i = sfx_freeslot0; i <= sfx_lastskinsoundslot; i++)
	{
		value = (i+1) - sfx_freeslot0;

		if (value < 10)
			sprintf(soundname, "fre00%d", value);
		else if (value < 100)
			sprintf(soundname, "fre0%d", value);
		else if (value < 1000)
			sprintf(soundname, "fre%d", value);
		else
			sprintf(soundname, "fr%d", value);

		strcpy(freeslotnames[value-1], soundname);

		S_sfx[i].name = freeslotnames[value-1];
		S_sfx[i].singularity = false;
		S_sfx[i].priority = 0;
		S_sfx[i].pitch = 0;
		S_sfx[i].volume = -1;
		S_sfx[i].data = NULL;
		S_sfx[i].length = 0;
		S_sfx[i].skinsound = -1;
		S_sfx[i].usefulness = -1;
		S_sfx[i].lumpnum = LUMPERROR;
	}
}

// Add a new sound fx into a free sfx slot.
//
sfxenum_t S_AddSoundFx(const char *name, boolean singular, INT32 flags, boolean skinsound)
{
	sfxenum_t i, slot;

	if (skinsound)
		slot = sfx_skinsoundslot0;
	else
		slot = sfx_freeslot0;

	for (i = slot; i < NUMSFX; i++)
	{
		if (!S_sfx[i].priority)
		{
			strncpy(freeslotnames[i-sfx_freeslot0], name, 6);
			S_sfx[i].singularity = singular;
			S_sfx[i].priority = 60;
			S_sfx[i].pitch = flags;
			S_sfx[i].volume = -1;
			S_sfx[i].lumpnum = LUMPERROR;
			S_sfx[i].skinsound = -1;
			S_sfx[i].usefulness = -1;

			/// \todo if precached load it here
			S_sfx[i].data = NULL;
			return i;
		}
	}
	CONS_Alert(CONS_WARNING, M_GetText("No more free sound slots\n"));
	return 0;
}

void S_RemoveSoundFx(sfxenum_t id)
{
	if (id >= sfx_freeslot0 && id <= sfx_lastskinsoundslot
		&& S_sfx[id].priority != 0)
	{
		S_sfx[id].lumpnum = LUMPERROR;
		I_FreeSfx(&S_sfx[id]);
		S_sfx[id].priority = 0;
	}
}
